/***************************************************************************
Copyright (c) 2006 Peter Korzuszek, Damian Rakowski, KateOS Project
 
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
 
*Redistributions of source code must retain the above copyright notice,
this list of conditions and the following disclaimer.
 
*Redistributions in binary form must reproduce the above copyright notice,
this list of conditions and the following disclaimer in the documentation
and/or other materials provided with the distribution.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS
IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE. 
****************************************************************************/

#ifndef SMART_TOOLS_TEMP_H
#define SMART_TOOLS_TEMP_H

#include "stdir.h"
#include "ststring.h"
#include "smarttools.h"

// errors
const int ER_STTEMP_MKDIR = 1;	// Error while mkdir
const int ER_STTEMP_ATTEMPTS = 2; 	// Max attempts of creation reached

/*
	\brief Manage temporary directoty
*/
class StTemp : public StDir
{
	public:
		StTemp(){ clearOnDestruct=false; }
		~StTemp(){ if( clearOnDestruct ) clear(); }
		/**
			Create the temporary direcory
			\param prefix - the first part of direcotry`s name
			\param path - path to temporary directory
			\param attempts - 
			\return True if the temporart directory has created
		*/ 
		bool create( const StString& prefix, const StString& path=ST_DEFAULT_TEMP, unsigned attempts=ST_FILE_CREATE_LIMIT );
		
		// usuwa katalog tymczasowy
		/**Delete the temporary directory*/
		void clear();
		
		/**Get path to temporary directory*/
		StString get(){ return getPath(); }
		//StString getString(){ if( !path.empty() ) return path; else return ST_DEFAULT_TEMP; }
		//StString getDir() { return StDir( getString() ); }
		
	
	private:
		//StString path;
		bool clearOnDestruct;
		
		friend StTemp& stTemp();
		
};

StTemp& stTemp();

#endif //SMART_TOOLS_TEMP_H
